## hashcat 6.2.5+ds1

=== src/Makefile ===
##
## Author......: See docs/credits.txt
## License.....: MIT
##

SHARED                  ?= 0
DEBUG                   := 0
PRODUCTION              := 1
PRODUCTION_VERSION      := v6.2.5
ENABLE_CUBIN            ?= 1
ENABLE_BRAIN            ?= 1
ENABLE_UNRAR            ?= 1
USE_SYSTEM_LZMA         ?= 0
USE_SYSTEM_ZLIB         ?= 0
USE_SYSTEM_OPENCL       ?= 0
USE_SYSTEM_XXHASH       ?= 0
## do not change, requires some hacks
USE_SYSTEM_UNRAR        ?= 0

##
## Detect Operating System
##

UNAME                   := $(shell uname -s)

# we need to strip the windows version number to be able to build hashcat on cygwin hosts
UNAME                   := $(patsubst CYGWIN_NT-%,CYGWIN,$(UNAME))

# same for msys
UNAME                   := $(patsubst MSYS_NT-%,MSYS2,$(UNAME))
UNAME                   := $(patsubst MINGW32_NT-%,MSYS2,$(UNAME))
UNAME                   := $(patsubst MINGW64_NT-%,MSYS2,$(UNAME))

ifeq (,$(filter $(UNAME),Linux FreeBSD Darwin CYGWIN MSYS2))
$(error "! Your Operating System ($(UNAME)) is not supported by this Makefile")
endif

ifeq ($(DEBUG),1)
$(warning "## Detected Operating System : $(UNAME)")
endif

##
## Makefile flags
##

MAKEFLAGS               += -l -j 8 -rR --no-print-directory

ifneq ($(findstring clean,$(MAKECMDGOALS)),)
MAKEFLAGS               += -j 1
endif

##
## Do not modify
##

MODULE_INTERFACE_VERSION := 630

##
## Native compiler paths
##

CC                      := gcc
CXX                     := g++
AR                      := ar
FIND                    := find
INSTALL                 := install
RM                      := rm
SED                     := sed
SED_IN_PLACE            := -i

ifeq ($(UNAME),Darwin)
CC                      := clang
CXX                     := clang++
# the sed -i option of macOS requires a parameter for the backup file (we just use "")
AR                      := /usr/bin/ar
SED                     := /usr/bin/sed
SED_IN_PLACE            := -i ""
DARWIN_VERSION          := $(shell uname -r | cut -d. -f1)
endif

ifeq ($(UNAME),FreeBSD)
CC                      := cc
CXX                     := c++
SED                     := gsed
endif

##
## Version
##

ifeq ($(PRODUCTION),1)
VERSION_TAG             := $(PRODUCTION_VERSION)
else
VERSION_TAG             := $(shell git describe --tags --dirty=+ || echo $(PRODUCTION_VERSION))
endif # PRODUCTION

VERSION_PURE            := $(shell echo "$(VERSION_TAG)" | $(SED) 's/.*v\([\.0-9]*\).*/\1/')

##
## Installation paths
##

DESTDIR                 ?=
PREFIX                  ?= /usr/local

INSTALL_FOLDER          ?= $(PREFIX)/bin
SHARED_ROOT_FOLDER      ?= $(PREFIX)/share
SHARED_FOLDER           ?= $(SHARED_ROOT_FOLDER)/hashcat
DOCUMENT_FOLDER         ?= $(SHARED_ROOT_FOLDER)/doc/hashcat
LIBRARY_FOLDER          ?= $(PREFIX)/lib
LIBRARY_DEV_ROOT_FOLDER ?= $(PREFIX)/include
LIBRARY_DEV_FOLDER      ?= $(LIBRARY_DEV_ROOT_FOLDER)/hashcat

##
## Dependencies paths
##

ifeq ($(USE_SYSTEM_LZMA),0)
DEPS_LZMA_PATH          := deps/LZMA-SDK/C
else
DEPS_LZMA_PATH          := $(LIBRARY_DEV_ROOT_FOLDER)
endif

ifeq ($(USE_SYSTEM_ZLIB),0)
DEPS_ZLIB_PATH          := deps/zlib
else
DEPS_ZLIB_PATH          := $(LIBRARY_DEV_ROOT_FOLDER)
endif

ifeq ($(USE_SYSTEM_OPENCL),0)
DEPS_OPENCL_PATH        := deps/OpenCL-Headers
else
DEPS_OPENCL_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)
endif

ifeq ($(USE_SYSTEM_XXHASH),0)
DEPS_XXHASH_PATH        := deps/xxHash
else
DEPS_XXHASH_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)
endif

ifeq ($(ENABLE_UNRAR),1)
ifeq ($(USE_SYSTEM_UNRAR),0)
DEPS_UNRAR_PATH         := deps/unrar
else
DEPS_UNRAR_PATH         := $(LIBRARY_DEV_ROOT_FOLDER)
endif
endif

##
## Filenames for library and frontend
##

HASHCAT_FRONTEND        := hashcat
HASHCAT_LIBRARY         := libhashcat.so.$(VERSION_PURE)

ifeq ($(UNAME),Darwin)
HASHCAT_LIBRARY         := libhashcat.$(VERSION_PURE).dylib
endif # Darwin

ifeq ($(UNAME),CYGWIN)
HASHCAT_FRONTEND        := hashcat.exe
HASHCAT_LIBRARY         := hashcat.dll
endif # CYGWIN

ifeq ($(UNAME),MSYS2)
HASHCAT_FRONTEND        := hashcat.exe
HASHCAT_LIBRARY         := hashcat.dll
endif # MSYS2

##
## Misc stuff
##

COMPTIME                := $(shell date +%s)

##
## General compiler and linker options
##

LFLAGS                  := $(LDFLAGS)

ifeq ($(PRODUCTION),0)
CFLAGS                  += -W
CFLAGS                  += -Wall
CFLAGS                  += -Wextra
endif

## because LZMA SDK
ifeq ($(CC),clang)
CFLAGS                  += -Wno-enum-conversion
CFLAGS                  += -Wno-typedef-redefinition
endif

ifeq ($(USE_SYSTEM_LZMA),0)
CFLAGS_LZMA             += -D_7ZIP_ST
CFLAGS_LZMA             += -Wno-misleading-indentation
endif

## because ZLIB
ifeq ($(USE_SYSTEM_ZLIB),0)
CFLAGS_ZLIB             += -Wno-implicit-fallthrough
CFLAGS_ZLIB             += -Wno-implicit-function-declaration
CFLAGS_ZLIB             += -Wno-unused-parameter
CFLAGS_ZLIB             += -DIOAPI_NO_64
CFLAGS_ZLIB             += -DUNZ_BUFSIZE=262144
endif

## because UNRAR
ifeq ($(ENABLE_UNRAR),1)
ifeq ($(USE_SYSTEM_UNRAR),0)
ifneq ($(CC),clang)
CFLAGS_UNRAR            += -Wno-class-memaccess
CFLAGS_UNRAR            += -Wno-misleading-indentation
endif
CFLAGS_UNRAR            += -Wno-missing-braces
CFLAGS_UNRAR            += -Wno-unused-variable
CFLAGS_UNRAR            += -Wno-unused-parameter
CFLAGS_UNRAR            += -Wno-unused-function
CFLAGS_UNRAR            += -Wno-sign-compare
CFLAGS_UNRAR            += -Wno-dangling-else
CFLAGS_UNRAR            += -Wno-switch
CFLAGS_UNRAR            += -Wno-parentheses
CFLAGS_UNRAR            += -Wno-implicit-fallthrough
CFLAGS_UNRAR            += -Wno-extra
CFLAGS_UNRAR            += -Wno-unknown-pragmas
endif
endif

ifeq ($(DEBUG),0)
CFLAGS                  += -O2
ifneq ($(UNAME),Darwin)
LFLAGS                  += -s
endif
else
ifeq ($(DEBUG),1)
ifneq ($(UNAME),Darwin)
CFLAGS                  += -DDEBUG -Og -ggdb
else
CFLAGS                  += -DDEBUG -O0 -ggdb
endif
else
ifeq ($(DEBUG),2)
ifneq ($(UNAME),Darwin)
CFLAGS                  += -DDEBUG -Og -ggdb
else
CFLAGS                  += -DDEBUG -O0 -ggdb
endif
CFLAGS                  += -fsanitize=address -fno-omit-frame-pointer
endif
endif
endif

CFLAGS                  += -pipe -Iinclude/ -IOpenCL/

# LZMA
CFLAGS                  += -I$(DEPS_LZMA_PATH)
ifeq ($(USE_SYSTEM_LZMA),1)
LFLAGS                  += -llzmasdk
endif

# ZLIB
CFLAGS                  += -I$(DEPS_ZLIB_PATH) -I$(DEPS_ZLIB_PATH)/contrib
ifeq ($(USE_SYSTEM_ZLIB),1)
LFLAGS                  += -lz -lminizip
endif

# OpenCL
CFLAGS                  += -I$(DEPS_OPENCL_PATH)

# brain and xxHash
ifeq ($(ENABLE_BRAIN),1)
CFLAGS                  += -DWITH_BRAIN
CFLAGS                  += -I$(DEPS_XXHASH_PATH)
ifeq ($(USE_SYSTEM_XXHASH),1)
LFLAGS                  += -lxxhash
endif
endif

# CUDA binary cache
ifeq ($(ENABLE_CUBIN),1)
CFLAGS                  += -DWITH_CUBIN
endif

# unrar
ifeq ($(ENABLE_UNRAR),1)
CFLAGS                  += -I$(DEPS_UNRAR_PATH)
LFLAGS                  += -lstdc++
endif

##
## Native compilation target
##

ifeq ($(UNAME),Linux)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -ldl
LFLAGS_NATIVE           += -lrt
LFLAGS_NATIVE           += -lm
endif # Linux

ifeq ($(UNAME),FreeBSD)
ifndef PORTNAME
CFLAGS_NATIVE           := $(CFLAGS)
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -lm
LFLAGS_NATIVE           += -liconv
endif
endif # FreeBSD

ifeq ($(UNAME),Darwin)
export MACOSX_DEPLOYMENT_TARGET=10.9
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -DWITH_HWMON

ifeq ($(shell test $(DARWIN_VERSION) -le 15; echo $$?), 0)
CFLAGS_NATIVE           += -DMISSING_CLOCK_GETTIME
endif

LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -framework OpenCL
LFLAGS_NATIVE           += -framework IOKit
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -liconv
endif # Darwin

ifeq ($(UNAME),CYGWIN)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -Wl,--dynamicbase
LFLAGS_NATIVE           += -Wl,--nxcompat
LFLAGS_NATIVE           += -lpsapi
LFLAGS_NATIVE           += -liconv
endif # CYGWIN

ifeq ($(UNAME),MSYS2)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -Wl,--dynamicbase
LFLAGS_NATIVE           += -Wl,--nxcompat
LFLAGS_NATIVE           += -lpsapi
LFLAGS_NATIVE           += -liconv
LFLAGS_NATIVE           += -lws2_32
LFLAGS_NATIVE           += -lpowrprof
endif # MSYS2

# CCFLAGS only for C compiler
CCFLAGS                 := -std=gnu99

# CXXFLAGS only for C++ compiler
CXXFLAGS                :=

##
## Objects
##

EMU_OBJS_ALL            := emu_general emu_inc_common emu_inc_platform emu_inc_scalar emu_inc_simd
EMU_OBJS_ALL            += emu_inc_rp emu_inc_rp_optimized
EMU_OBJS_ALL            += emu_inc_hash_md4 emu_inc_hash_md5 emu_inc_hash_ripemd160 emu_inc_hash_sha1 emu_inc_hash_sha256 emu_inc_hash_sha384 emu_inc_hash_sha512 emu_inc_hash_streebog256 emu_inc_hash_streebog512 emu_inc_ecc_secp256k1
EMU_OBJS_ALL            += emu_inc_cipher_aes emu_inc_cipher_camellia emu_inc_cipher_des emu_inc_cipher_kuznyechik emu_inc_cipher_serpent emu_inc_cipher_twofish

OBJS_ALL                := affinity autotune backend benchmark bitmap bitops combinator common convert cpt cpu_crc32 debugfile dictstat dispatch dynloader event ext_ADL ext_cuda ext_hip ext_nvapi ext_nvml ext_nvrtc ext_hiprtc ext_OpenCL ext_sysfs_amdgpu ext_sysfs_cpu ext_iokit ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface keyboard_layout locking logfile loopback memory monitor mpsp outfile_check outfile pidfile potfile restore rp rp_cpu selftest slow_candidates shared status stdout straight terminal thread timer tuningdb usage user_options wordlist $(EMU_OBJS_ALL)

ifeq ($(ENABLE_BRAIN),1)
OBJS_ALL                += brain
endif

NATIVE_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.o)
LINUX_OBJS              := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).LINUX.o)
WIN_OBJS                := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.o)

ifeq ($(USE_SYSTEM_LZMA),0)
OBJS_LZMA               := 7zCrc 7zCrcOpt 7zFile 7zStream Alloc Bra Bra86 BraIA64 CpuArch Delta LzmaDec Lzma2Dec Sha256 Sha256Opt Xz XzCrc64 XzCrc64Opt XzDec XzIn

NATIVE_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LZMA.NATIVE.o)
LINUX_OBJS              += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LZMA.LINUX.o)
WIN_OBJS                += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LZMA.WIN.o)
endif

ifeq ($(USE_SYSTEM_ZLIB),0)
OBJS_ZLIB               := adler32 crc32 deflate inflate inffast inftrees trees gzread gzwrite gzclose zutil gzlib contrib/minizip/unzip contrib/minizip/ioapi

NATIVE_OBJS             += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).ZLIB.NATIVE.o)
LINUX_OBJS              += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).ZLIB.LINUX.o)
WIN_OBJS                += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).ZLIB.WIN.o)
endif

ifeq ($(USE_SYSTEM_XXHASH),0)
ifeq ($(ENABLE_BRAIN),1)
OBJS_XXHASH             := xxhash

NATIVE_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).XXHASH.NATIVE.o)
LINUX_OBJS              += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).XXHASH.LINUX.o)
WIN_OBJS                += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).XXHASH.WIN.o)
endif
endif

ifeq ($(ENABLE_UNRAR),1)
ifeq ($(USE_SYSTEM_UNRAR),0)
OBJS_UNRAR              := strlist strfn pathfn smallfn global file filefn filcreat archive arcread unicode system isnt crypt crc rawread encname resource match timefn rdwrfn consio options errhnd rarvm secpassword rijndael getbits sha1 sha256 blake2s hash extinfo extract volume list find unpack headers threadpool rs16 cmddata ui filestr recvol rs scantree qopen hc_decompress_rar

=== debian/changelog ===
hashcat (6.2.5+ds1-2) unstable; urgency=medium

  * Team Upload.
  * Fix the build on armhf ("selected architecture lacks an FPU")

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 23 Dec 2021 14:53:02 +0100

hashcat (6.2.5+ds1-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 6.2.5+ds1
  * Update debian/copyright
  * Refresh patches
  * Bump Standards-Version to 4.6.0 (no change)
  * Update debian/upstream/metadata

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 22 Dec 2021 16:19:44 +0100

=== debian/control ===
Source: hashcat
Section: net
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Daniel Echeverry <epsilon77@gmail.com>
Build-Depends: debhelper-compat (= 12),
               libgmp-dev,
	       libminizip-dev,
               libxxhash-dev,
	       zlib1g-dev,
               opencl-headers
Standards-Version: 4.6.0
Homepage: https://hashcat.net/hashcat/
Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat

Package: hashcat
Architecture: kfreebsd-any amd64 i386 armhf arm64
Depends: hashcat-data (>= ${source:Version}),
         pocl-opencl-icd | opencl-icd,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: beignet-opencl-icd, nvidia-opencl-icd, mesa-opencl-icd
Description: World's fastest and most advanced password recovery utility
 Hashcat supports five unique modes of attack for over 300 highly-optimized
 hashing algorithms. hashcat currently supports CPUs, GPUs, and other
 hardware accelerators on Linux, and has facilities to help enable
 distributed password cracking.
 .
 Examples of hashcat supported hashing algorithms are:
 MD5, HMAC-MD5, SHA1, HMAC-SHA1, MySQL323, MySQL4.1/MySQL5, phpass,
 MD5(Wordpress), MD5(phpBB3), MD5(Joomla), md5crypt, MD5(Unix),
 FreeBSD MD5, Cisco-IOS, MD4, NTLM, Domain Cached Credentials (DCC),
 MS Cache, SHA256, HMAC-SHA256, md5apr1, MD5(APR), Apache MD5, SHA512,
 HMAC-SHA512, Cisco-PIX, Cisco-ASA, WPA/WPA2, Double MD5, bcrypt,
 Blowfish(OpenBSD), MD5(Sun), Double SHA1, SHA-3(Keccak),Half MD5,
 Password Safe SHA-256, IKE-PSK MD5, IKE-PSK SHA1,
 NetNTLMv1-VANILLA/NetNTLMv1-ESS, NetNTLMv2, Cisco-IOS SHA256,
 Android PIN, AIX {smd5}, AIX {ssha256}, AIX {ssha512}, AIX {ssha1},
 GOST, GOST R 34, Fortigate (FortiOS), OS X v10.8+, GRUB 2, IPMI2, RAKP,
 HMAC-SHA1, sha256crypt, SHA256(Unix), Drupal7, WBB3, scrypt, Cisco $8$,
 Cisco $9$, Radmin2, Django (PBKDF2-SHA256), Cram MD5, SAP, iSSHA-1,
 PrestaShop, PostgreSQL, Challenge-Response Authentication (MD5),
 MySQL Challenge-Response, Authentication (SHA1),
 SIP digest authentication (MD5), Plaintext, Joomla < 2.5.18, PostgreSQL,
 osCommerce, xt:Commerce, Skype, nsldap, Netscape, LDAP, nsldaps,
 SSHA-1(Base64), Oracle S: Type (Oracle 11+), SMF > v1.1, OS X v10.4,
 v10.5, v10.6, EPi, Django (SHA-1), MSSQL(2000), MSSQL(2005),
 PeopleSoft, EPiServer 6.x < v4, hMailServer, SSHA-512(Base64),
 LDAP {SSHA512}, OS X v10.7, MSSQL(2012 & 2014), vBulletin < v3.8.5,
 PHPS, vBulletin > v3.8.5, IPB2+, MyBB1.2+, Mediawiki B type,
 WebEdition CMS, Redmine.
 .
 Hashcat offers multiple attack modes for obtaining effective and
 complex coverage over a hash's keyspace. These modes are:
 .
  * Brute-Force attack
  * Combinator attack
  * Dictionary attack
  * Fingerprint attack
  * Hybrid attack
  * Mask attack
  * Permutation attack
  * Rule-based attack
  * Table-Lookup attack
  * Toggle-Case attack
  * PRINCE attack

Package: hashcat-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: hashcat
Replaces: hashcat (<= 2.00-0kali3)
Description: Data files for hashcat advanced password recovery utility
 Hashcat is an advanced CPU/GPU-based password recovery utility supporting
 seven unique modes of attack for over 100 optimized hashing algorithms.
 .
 This package contains the data files for hashcat, including charsets,
 rules, salts, and tables.

## hashcat 6.2.6%2Bds2

=== src/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 SHARED                  ?= 0
 DEBUG                   := 0
 PRODUCTION              := 1
-PRODUCTION_VERSION      := v6.2.5
+PRODUCTION_VERSION      := v6.2.6
 ENABLE_CUBIN            ?= 1
 ENABLE_BRAIN            ?= 1
 ENABLE_UNRAR            ?= 1
@@ -31,12 +31,12 @@
 UNAME                   := $(patsubst MINGW32_NT-%,MSYS2,$(UNAME))
 UNAME                   := $(patsubst MINGW64_NT-%,MSYS2,$(UNAME))
 
-ifeq (,$(filter $(UNAME),Linux FreeBSD Darwin CYGWIN MSYS2))
+ifeq (,$(filter $(UNAME),Linux FreeBSD NetBSD Darwin CYGWIN MSYS2))
 $(error "! Your Operating System ($(UNAME)) is not supported by this Makefile")
 endif
 
 ifeq ($(DEBUG),1)
-$(warning "## Detected Operating System : $(UNAME)")
+$(info "## Detected Operating System : $(UNAME)")
 endif
 
 ##
@@ -53,7 +53,7 @@
 ## Do not modify
 ##
 
-MODULE_INTERFACE_VERSION := 630
+MODULE_INTERFACE_VERSION := 700
 
 ##
 ## Native compiler paths
@@ -76,9 +76,10 @@
 SED                     := /usr/bin/sed
 SED_IN_PLACE            := -i ""
 DARWIN_VERSION          := $(shell uname -r | cut -d. -f1)
-endif
-
-ifeq ($(UNAME),FreeBSD)
+IS_APPLE_SILICON        := $(shell lipo /bin/zsh -verify_arch arm64e && echo 1 || echo 0)
+endif
+
+ifneq (,$(filter $(UNAME),FreeBSD NetBSD))
 CC                      := cc
 CXX                     := c++
 SED                     := gsed
@@ -194,7 +195,9 @@
 
 ifeq ($(USE_SYSTEM_LZMA),0)
 CFLAGS_LZMA             += -D_7ZIP_ST
+ifneq ($(CC),clang)
 CFLAGS_LZMA             += -Wno-misleading-indentation
+endif
 endif
 
 ## because ZLIB
@@ -224,6 +227,8 @@
 CFLAGS_UNRAR            += -Wno-implicit-fallthrough
 CFLAGS_UNRAR            += -Wno-extra
 CFLAGS_UNRAR            += -Wno-unknown-pragmas
+CFLAGS_UNRAR            += -Wno-unused-but-set-variable
+CFLAGS_UNRAR            += -Wno-format-overflow
 endif
 endif
 
@@ -248,6 +253,14 @@
 endif
 CFLAGS                  += -fsanitize=address -fno-omit-frame-pointer
 endif
+endif
+endif
+
+ifeq ($(UNAME),Linux)
+IS_RPI                  := $(shell grep -q Raspberry /proc/cpuinfo && echo 1 || echo 0)
+
+ifeq ($(IS_RPI),1)
+CFLAGS                  += -mcpu=cortex-a72
 endif
 endif
 
@@ -312,8 +325,14 @@
 endif
 endif # FreeBSD
 
+ifeq ($(UNAME),NetBSD)
+CFLAGS_NATIVE           := $(CFLAGS)
+LFLAGS_NATIVE           := $(LFLAGS)
+LFLAGS_NATIVE           += -lpthread
+endif # NetBSD
+
 ifeq ($(UNAME),Darwin)
-export MACOSX_DEPLOYMENT_TARGET=10.9
+export MACOSX_DEPLOYMENT_TARGET=10.15
 CFLAGS_NATIVE           := $(CFLAGS)
 CFLAGS_NATIVE           += -DWITH_HWMON
 
@@ -322,10 +341,23 @@
 endif
 
 LFLAGS_NATIVE           := $(LFLAGS)
-LFLAGS_NATIVE           += -framework OpenCL
+LFLAGS_NATIVE           += -framework CoreFoundation
+LFLAGS_NATIVE           += -framework CoreGraphics
+LFLAGS_NATIVE           += -framework Foundation
 LFLAGS_NATIVE           += -framework IOKit
+LFLAGS_NATIVE           += -framework Metal
 LFLAGS_NATIVE           += -lpthread
 LFLAGS_NATIVE           += -liconv
+
+ifeq ($(IS_APPLE_SILICON),1)
+CFLAGS_NATIVE           += -arch arm64
+CFLAGS_NATIVE           += -arch x86_64
+ifeq ($(SHARED),1)
+LFLAGS_NATIVE           += -arch arm64
+LFLAGS_NATIVE           += -arch x86_64
+endif
+endif
+
 endif # Darwin
 
 ifeq ($(UNAME),CYGWIN)
@@ -362,10 +394,15 @@
 
 EMU_OBJS_ALL            := emu_general emu_inc_common emu_inc_platform emu_inc_scalar emu_inc_simd
 EMU_OBJS_ALL            += emu_inc_rp emu_inc_rp_optimized
-EMU_OBJS_ALL            += emu_inc_hash_md4 emu_inc_hash_md5 emu_inc_hash_ripemd160 emu_inc_hash_sha1 emu_inc_hash_sha256 emu_inc_hash_sha384 emu_inc_hash_sha512 emu_inc_hash_streebog256 emu_inc_hash_streebog512 emu_inc_ecc_secp256k1
+EMU_OBJS_ALL            += emu_inc_hash_md4 emu_inc_hash_md5 emu_inc_hash_ripemd160 emu_inc_hash_sha1 emu_inc_hash_sha256 emu_inc_hash_sha384 emu_inc_hash_sha512 emu_inc_hash_streebog256 emu_inc_hash_streebog512 emu_inc_ecc_secp256k1 emu_inc_bignum_operations
 EMU_OBJS_ALL            += emu_inc_cipher_aes emu_inc_cipher_camellia emu_inc_cipher_des emu_inc_cipher_kuznyechik emu_inc_cipher_serpent emu_inc_cipher_twofish
+EMU_OBJS_ALL            += emu_inc_hash_base58
 
 OBJS_ALL                := affinity autotune backend benchmark bitmap bitops combinator common convert cpt cpu_crc32 debugfile dictstat dispatch dynloader event ext_ADL ext_cuda ext_hip ext_nvapi ext_nvml ext_nvrtc ext_hiprtc ext_OpenCL ext_sysfs_amdgpu ext_sysfs_cpu ext_iokit ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface keyboard_layout locking logfile loopback memory monitor mpsp outfile_check outfile pidfile potfile restore rp rp_cpu selftest slow_candidates shared status stdout straight terminal thread timer tuningdb usage user_options wordlist $(EMU_OBJS_ALL)
+
+ifeq ($(UNAME),Darwin)
+OBJS_ALL                += ext_metal
+endif
 
 ifeq ($(ENABLE_BRAIN),1)
 OBJS_ALL                += brain
@@ -384,24 +421,3 @@
 endif
 
 ifeq ($(USE_SYSTEM_ZLIB),0)
-OBJS_ZLIB               := adler32 crc32 deflate inflate inffast inftrees trees gzread gzwrite gzclose zutil gzlib contrib/minizip/unzip contrib/minizip/ioapi
-
-NATIVE_OBJS             += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).ZLIB.NATIVE.o)
-LINUX_OBJS              += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).ZLIB.LINUX.o)
-WIN_OBJS                += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).ZLIB.WIN.o)
-endif
-
-ifeq ($(USE_SYSTEM_XXHASH),0)
-ifeq ($(ENABLE_BRAIN),1)
-OBJS_XXHASH             := xxhash
-
-NATIVE_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).XXHASH.NATIVE.o)
-LINUX_OBJS              += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).XXHASH.LINUX.o)
-WIN_OBJS                += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).XXHASH.WIN.o)
-endif
-endif
-
-ifeq ($(ENABLE_UNRAR),1)
-ifeq ($(USE_SYSTEM_UNRAR),0)
-OBJS_UNRAR              := strlist strfn pathfn smallfn global file filefn filcreat archive arcread unicode system isnt crypt crc rawread encname resource match timefn rdwrfn consio options errhnd rarvm secpassword rijndael getbits sha1 sha256 blake2s hash extinfo extract volume list find unpack headers threadpool rs16 cmddata ui filestr recvol rs scantree qopen hc_decompress_rar
-

## hashcat 6.2.6+ds1

=== debian/changelog ===
hashcat (6.2.6+ds1-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:52:34 +1100

hashcat (6.2.6+ds1-1build1) noble; urgency=medium

  * No-change rebuild against libminizip1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 03:30:47 +0000

hashcat (6.2.6+ds1-1) unstable; urgency=medium

  * Team Upload.

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.

  [ Sophie Brun ]
  * New upstream version 6.2.6+ds1
  * Refresh patches
  * Bump Standards-Version to 4.6.1
  * Install new files: tunings/* tools/*
  * Add missing dep Python3
  * Update lintian-overrides
  * Add a patch to fix lintian warnings about shebangs

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 06 Oct 2022 11:50:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: hashcat
 Section: net
 Priority: optional
-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Daniel Echeverry <epsilon77@gmail.com>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libgmp-dev,
 	       libminizip-dev,
                libxxhash-dev,
 	       zlib1g-dev,
                opencl-headers
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://hashcat.net/hashcat/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat
@@ -69,7 +70,7 @@
 Package: hashcat-data
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, python3
 Suggests: hashcat
 Replaces: hashcat (<= 2.00-0kali3)
 Description: Data files for hashcat advanced password recovery utility
@@ -77,4 +78,4 @@
  seven unique modes of attack for over 100 optimized hashing algorithms.
  .
  This package contains the data files for hashcat, including charsets,
- rules, salts, and tables.
+ rules, salts, tables and Python tools.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -lminizip

ifeq (armhf, $(DEB_HOST_ARCH))
        export DEB_CFLAGS_MAINT_APPEND = -mfpu=vfpv3-d16
endif

MAKEFILE_VARIABLES = PREFIX=/usr COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1 USE_SYSTEM_ZLIB=1

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(MAKEFILE_VARIABLES)

override_dh_auto_install:
	dh_auto_install -- $(MAKEFILE_VARIABLES)

override_dh_install:
	rm -f debian/tmp/usr/share/doc/hashcat/docs/changes.txt
	rm -f debian/tmp/usr/share/doc/hashcat/docs/license.txt
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs docs/changes.txt

override_dh_fixperms-indep:
	dh_fixperms
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example0.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example400.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example500.sh

## hashcat 6.2.6+ds2

=== debian/changelog ===
hashcat (6.2.6+ds2-1) unstable; urgency=medium
 
  * Team Upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)
  * Apply multi-arch hints. + hashcat-data: Add :any qualifier for python3 dependency.

  [ Sophie Brun ]
  * Remove non-free code (Closes: #1065934) and disable build with unrar
  * New upstream version 6.2.6+ds2
  * Add missing copyright for deps/*

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 24 Apr 2024 12:01:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: hashcat
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Daniel Echeverry <epsilon77@gmail.com>
 Build-Depends: debhelper-compat (= 13),
                libgmp-dev,
@@ -70,9 +69,8 @@
 Package: hashcat-data
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, python3
+Depends: ${misc:Depends}, python3:any
 Suggests: hashcat
-Replaces: hashcat (<= 2.00-0kali3)
 Description: Data files for hashcat advanced password recovery utility
  Hashcat is an advanced CPU/GPU-based password recovery utility supporting
  seven unique modes of attack for over 100 optimized hashing algorithms.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
         export DEB_CFLAGS_MAINT_APPEND = -mfpu=vfpv3-d16
 endif
 
-MAKEFILE_VARIABLES = PREFIX=/usr COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1 USE_SYSTEM_ZLIB=1
+MAKEFILE_VARIABLES = PREFIX=/usr COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1 USE_SYSTEM_ZLIB=1 ENABLE_UNRAR=0
 
 %:
 	dh $@

## hashcat 7.1.2%2Bds1

=== deps/yescrypt-master/Makefile ===
# Copyright 2013-2018 Alexander Peslyak
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

CC = gcc
LD = $(CC)
RM = rm -f
OMPFLAGS = -fopenmp
OMPFLAGS_MAYBE = $(OMPFLAGS)
# hashcat: we don't use this Makefile, but: https://github.com/hashcat/hashcat/pull/4385
CFLAGS = -Wall -O2 -fomit-frame-pointer $(OMPFLAGS_MAYBE) -DSKIP_MEMZERO
#CFLAGS = -Wall -O2 -march=native -fomit-frame-pointer $(OMPFLAGS_MAYBE) -DSKIP_MEMZERO
#CFLAGS = -Wall -O2 -funroll-loops -fomit-frame-pointer $(OMPFLAGS_MAYBE) -DSKIP_MEMZERO
#CFLAGS = -Wall -O2 -march=native -funroll-loops -fomit-frame-pointer $(OMPFLAGS_MAYBE) -DSKIP_MEMZERO
# -lrt is for userom's use of clock_gettime()
LDFLAGS = -s -lrt $(OMPFLAGS_MAYBE)

PROJ = tests phc-test initrom userom
OBJS_CORE = yescrypt-opt.o
OBJS_COMMON = yescrypt-common.o sha256.o insecure_memzero.o
OBJS_TESTS = $(OBJS_CORE) $(OBJS_COMMON) tests.o
OBJS_PHC = $(OBJS_CORE) $(OBJS_COMMON) phc-test.o
OBJS_INITROM = $(OBJS_CORE) $(OBJS_COMMON) initrom.o
OBJS_USEROM = $(OBJS_CORE) $(OBJS_COMMON) userom.o
OBJS_RM = yescrypt-*.o

all: $(PROJ)

check: tests phc-test
	@echo 'Running main tests'
	@time ./tests | tee TESTS-OUT
	@diff -U0 TESTS-OK TESTS-OUT && echo PASSED || echo FAILED
	@if [ -e PHC-TEST-OK-SHA256 ]; then \
		echo 'Running PHC tests'; \
		time ./phc-test > PHC-TEST-OUT; \
		sha256sum -c PHC-TEST-OK-SHA256; \
	fi

ref:
	$(MAKE) $(PROJ) OBJS_CORE=yescrypt-ref.o

check-ref:
	$(MAKE) check OBJS_CORE=yescrypt-ref.o

tests: $(OBJS_TESTS)
	$(LD) $(LDFLAGS) $(OBJS_TESTS) -o $@

phc-test.o: phc.c
	$(CC) -c $(CFLAGS) -DTEST phc.c -o $@

phc-test: $(OBJS_PHC)
	$(LD) $(LDFLAGS) $(OBJS_PHC) -o $@

initrom: $(OBJS_INITROM)
	$(LD) $(LDFLAGS) $(OBJS_INITROM) -o $@

userom: $(OBJS_USEROM)
	$(LD) $(LDFLAGS) $(OMPFLAGS) $(OBJS_USEROM) -o $@

userom.o: userom.c
	$(CC) -c $(CFLAGS) $(OMPFLAGS) $*.c

.c.o:
	$(CC) -c $(CFLAGS) $*.c

yescrypt-opt.o: yescrypt-platform.c

clean:
	$(RM) $(PROJ)
	$(RM) $(OBJS_TESTS) $(OBJS_PHC) $(OBJS_INITROM) $(OBJS_USEROM)
	$(RM) $(OBJS_RM)
	$(RM) TESTS-OUT PHC-TEST-OUT
